require 'helper'

class TestShopifyAppRankings < Test::Unit::TestCase
  MINIMUM_APPS = 40

  def test_top
    newest = Shopify::AppStore.top(:newest)
    assert(newest.size > MINIMUM_APPS)

    check_fields(newest.first)

    [ :popular, :highest_rated ].each do |type|
      assert_equal(Shopify::AppStore.top(type).size, newest.size)
    end
    assert_raise RuntimeError do
      Shopify::AppStore.top(:dummy)
    end
  end

  def test_find
    app = Shopify::AppStore.find('directed-edge-expressrex', :popular)
    check_fields(app)
    assert_nil(Shopify::AppStore.find('dummy', :popular))
  end

  private

  def check_fields(app)
    [ :handle, :name, :rank, :url, :image, :description ].each { |f| assert_not_nil(app[f]) }
  end
end
